/* eslint-disable import/export */
/* eslint-disable @typescript-eslint/no-namespace */
import { encodeMessage, decodeMessage, message, enumeration } from 'protons-runtime';
export var FetchRequest;
(function (FetchRequest) {
    let _codec;
    FetchRequest.codec = () => {
        if (_codec == null) {
            _codec = message((obj, writer, opts = {}) => {
                if (opts.lengthDelimited !== false) {
                    writer.fork();
                }
                if (obj.identifier != null) {
                    writer.uint32(10);
                    writer.string(obj.identifier);
                }
                else {
                    throw new Error('Protocol error: required field "identifier" was not found in object');
                }
                if (opts.lengthDelimited !== false) {
                    writer.ldelim();
                }
            }, (reader, length) => {
                const obj = {};
                const end = length == null ? reader.len : reader.pos + length;
                while (reader.pos < end) {
                    const tag = reader.uint32();
                    switch (tag >>> 3) {
                        case 1:
                            obj.identifier = reader.string();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                    }
                }
                if (obj.identifier == null) {
                    throw new Error('Protocol error: value for required field "identifier" was not found in protobuf');
                }
                return obj;
            });
        }
        return _codec;
    };
    FetchRequest.encode = (obj) => {
        return encodeMessage(obj, FetchRequest.codec());
    };
    FetchRequest.decode = (buf) => {
        return decodeMessage(buf, FetchRequest.codec());
    };
})(FetchRequest || (FetchRequest = {}));
export var FetchResponse;
(function (FetchResponse) {
    let StatusCode;
    (function (StatusCode) {
        StatusCode["OK"] = "OK";
        StatusCode["NOT_FOUND"] = "NOT_FOUND";
        StatusCode["ERROR"] = "ERROR";
    })(StatusCode = FetchResponse.StatusCode || (FetchResponse.StatusCode = {}));
    let __StatusCodeValues;
    (function (__StatusCodeValues) {
        __StatusCodeValues[__StatusCodeValues["OK"] = 0] = "OK";
        __StatusCodeValues[__StatusCodeValues["NOT_FOUND"] = 1] = "NOT_FOUND";
        __StatusCodeValues[__StatusCodeValues["ERROR"] = 2] = "ERROR";
    })(__StatusCodeValues || (__StatusCodeValues = {}));
    (function (StatusCode) {
        StatusCode.codec = () => {
            return enumeration(__StatusCodeValues);
        };
    })(StatusCode = FetchResponse.StatusCode || (FetchResponse.StatusCode = {}));
    let _codec;
    FetchResponse.codec = () => {
        if (_codec == null) {
            _codec = message((obj, writer, opts = {}) => {
                if (opts.lengthDelimited !== false) {
                    writer.fork();
                }
                if (obj.status != null) {
                    writer.uint32(8);
                    FetchResponse.StatusCode.codec().encode(obj.status, writer);
                }
                else {
                    throw new Error('Protocol error: required field "status" was not found in object');
                }
                if (obj.data != null) {
                    writer.uint32(18);
                    writer.bytes(obj.data);
                }
                else {
                    throw new Error('Protocol error: required field "data" was not found in object');
                }
                if (opts.lengthDelimited !== false) {
                    writer.ldelim();
                }
            }, (reader, length) => {
                const obj = {};
                const end = length == null ? reader.len : reader.pos + length;
                while (reader.pos < end) {
                    const tag = reader.uint32();
                    switch (tag >>> 3) {
                        case 1:
                            obj.status = FetchResponse.StatusCode.codec().decode(reader);
                            break;
                        case 2:
                            obj.data = reader.bytes();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                    }
                }
                if (obj.status == null) {
                    throw new Error('Protocol error: value for required field "status" was not found in protobuf');
                }
                if (obj.data == null) {
                    throw new Error('Protocol error: value for required field "data" was not found in protobuf');
                }
                return obj;
            });
        }
        return _codec;
    };
    FetchResponse.encode = (obj) => {
        return encodeMessage(obj, FetchResponse.codec());
    };
    FetchResponse.decode = (buf) => {
        return decodeMessage(buf, FetchResponse.codec());
    };
})(FetchResponse || (FetchResponse = {}));
//# sourceMappingURL=proto.js.map